namespace Microsoft.SilverlightMediaFramework.Core.TemplateDefinitions
{
    internal static class SMFPlayerVisualStates
    {
        internal static class GroupNames
        {
            internal const string AudioStreamMetadataAvailableStates = "AudioStreamMetadataAvailableStates";
            internal const string CaptionsStates = "CaptionsStates";
            internal const string ChapterStates = "ChapterStates";
            internal const string CommonStates = "CommonStates";
            internal const string LoggingConsoleStates = "LoggingConsoleStates";
            internal const string FullScreenStates = "FullScreenStates";
            internal const string MediaAdaptiveStates = "MediaAdaptiveStates";
            internal const string MediaLiveStates = "MediaLiveStates";
            internal const string PlaylistStates = "PlaylistStates";
            internal const string PlaySpeedStates = "PlaySpeedStates";
            internal const string PlayStates = "PlayStates";
            internal const string PositionLiveStates = "PositionLiveStates";
            internal const string PosterStates = "PosterStates";
            internal const string RetryingStates = "RetryingStates";
            internal const string SlowMotionEnabledStates = "SlowMotionEnabledStates";
            internal const string VersionInformationStates = "VersionInformationStates";
            internal const string PlayerGraphStates = "PlayerGraphStates";
            internal const string ControlStripStates = "ControlStripStates";
        }

        internal static class ControlStripStates
        {
            internal const string ControlStripVisible = "ControlStripVisible";
            internal const string ControlStripNotVisible = "ControlStripNotVisible";
        }

        internal static class PlayerGraphStates
        {
            internal const string PlayerGraphVisible = "PlayerGraphVisible";
            internal const string PlayerGraphHidden = "PlayerGraphHidden";
            internal const string PlayerGraphDisabled = "PlayerGraphDisabled";
        }

        internal static class MediaLiveStates
        {
            internal const string MediaLive = "MediaLive";
            internal const string MediaNotLive = "MediaNotLive";
        }

        internal static class PositionLiveStates
        {
            internal const string PositionLive = "PositionLive";
            internal const string PositionNotLive = "PositionNotLive";
        }

        internal static class MediaAdaptiveStates
        {
            internal const string MediaAdaptive = "MediaAdaptive";
            internal const string MediaNotAdaptive = "MediaNotAdaptive";
        }

        internal static class PlayStates
        {
            internal const string AcquiringLicense = "AcquiringLicense";
            internal const string Buffering = "Buffering";
            internal const string Closed = "Closed";
            internal const string Individualizing = "Individualizing";
            internal const string Opening = "Opening";
            internal const string Paused = "Paused";
            internal const string Playing = "Playing";
            internal const string Stopped = "Stopped";
            internal const string ClipPlaying = "ClipPlaying";
        }

        internal static class PlaySpeedStates
        {
            internal const string FastForwarding = "FastForwarding";
            internal const string Rewinding = "Rewinding";
            internal const string SlowMotion = "SlowMotion";
            internal const string NormalPlayback = "NormalPlayback";
        }





        internal static class AudioStreamMetadataAvailableStates
        {
            internal const string AudioStreamMetadataAvailable = "AudioStreamMetadataAvailable";
            internal const string AudioStreamMetadataNotAvailable = "AudioStreamMetadataNotAvailable";
        }

        internal static class CommonStates
        {
            internal const string Normal = "Normal";
            internal const string MouseOver = "MouseOver";
        }

        internal static class RetryingStates
        {
            internal const string Retrying = "Retrying";
            internal const string NotRetrying = "NotRetrying";
            internal const string RetryFailed = "RetryFailed";
        }

        internal static class FullScreenStates
        {
            internal const string FullScreen = "FullScreen";
            internal const string NotFullScreen = "NotFullScreen";
        }

        internal static class PosterStates
        {
            internal const string PosterVisible = "PosterVisible";
            internal const string PosterHidden = "PosterHidden";
        }

        internal static class AdStates
        {
            internal const string AdVisible = "AdVisible";
            internal const string AdHidden = "AdHidden";
        }

        internal static class PlaylistStates
        {
            internal const string PlaylistVisible = "PlaylistVisible";
            internal const string PlaylistHidden = "PlaylistHidden";
            internal const string PlaylistDisabled = "PlaylistDisabled";
        }

        internal static class ChapterStates
        {
            internal const string ChaptersVisible = "ChaptersVisible";
            internal const string ChaptersHidden = "ChaptersHidden";
            internal const string ChaptersDisabled = "ChaptersDisabled";
        }

        internal static class CaptionsStates
        {
            internal const string CaptionsVisible = "CaptionsVisible";
            internal const string CaptionsHidden = "CaptionsHidden";
            internal const string CaptionsDisabled = "CaptionsDisabled";
        }

        internal static class LoggingConsoleStates
        {
            internal const string LoggingConsoleVisible = "LoggingConsoleVisible";
            internal const string LoggingConsoleHidden = "LoggingConsoleHidden";
            internal const string LoggingConsoleDisabled = "LoggingConsoleDisabled";
        }

        internal static class SlowMotionEnabledStates
        {
            internal const string SlowMotionEnabled = "SlowMotionEnabled";
            internal const string SlowMotionDisabled = "SlowMotionDisabled";
        }

        internal static class VersionInformationStates
        {
            internal const string VersionInformationVisible = "VersionInformationVisible";
            internal const string VersionInformationHidden = "VersionInformationHidden";
            internal const string VersionInformationDisabled = "VersionInformationDisabled";
        }

    }
}
